{-| Module  : FiniteCategories
Description : Run all finite categories examples.
Copyright   : Guillaume Sabbagh 2022
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

Run all finite categories examples. See results in the folder 
-}

module Math.FiniteCategories.Examples
(
    main
)
where
    import qualified Math.FiniteCategories.NumberCategory.Example       as NumberCategory
    import qualified Math.FiniteCategories.DiscreteCategory.Example     as DiscreteCategory
    import qualified Math.FiniteCategories.Hat.Example                  as Hat
    import qualified Math.FiniteCategories.V.Example                    as V
    import qualified Math.FiniteCategories.Parallel.Example             as Parallel
    import qualified Math.FiniteCategories.Square.Example               as Square
    import qualified Math.FiniteCategories.Ens.Example                  as Ens
    import qualified Math.FiniteCategories.FinGrph.Example              as FinGrph
    import qualified Math.FiniteCategories.Opposite.Example             as Opposite
    import qualified Math.FiniteCategories.FinCat.Example               as FinCat
    import qualified Math.FiniteCategories.FunctorCategory.Example      as FunctorCategory
    import qualified Math.FiniteCategories.CompositionGraph.Example     as CompositionGraph
    import qualified Math.FiniteCategories.SafeCompositionGraph.Example as SafeCompositionGraph
    import qualified Math.FiniteCategories.CommaCategory.Example        as CommaCategory
    import qualified Math.FiniteCategories.One.Example                  as One
    import qualified Math.FiniteCategories.ConeCategory.Example         as ConeCategory
    
    -- | Run all examples of the project. See results in the folder OutputGraphViz.
    main = do
        NumberCategory.main
        DiscreteCategory.main
        Hat.main
        V.main
        Parallel.main
        Square.main
        Ens.main
        FinGrph.main
        Opposite.main
        FinCat.main
        FunctorCategory.main
        CompositionGraph.main
        SafeCompositionGraph.main
        CommaCategory.main
        One.main
        ConeCategory.main